#include <pthread.h>
#include <signal.h>
#include <ctype.h>
#include <fstream>

using namespace std;

#include "thread.h"
#include "gtk_iface.h"

gtk::gtk(int * ac, char *** av)
{
gtk_init(ac, av);
thread_running=false;
configured=false;
quit=false;

question=NULL;
main_pid=getpid();
	for(int i=0;i<3;i++){
	text[i]=new char[1024];
	text[i][0]=0;
	}
}

gtk::~gtk()
{
	if(thread_running){
	quit=true;
		while(quit) usleep(100000);
	}
}

void gtk::eatkey()
{
exiting=true;
	while(thread_running) usleep(100000);
}

void gtk::msg(int l,char *fmt,...)
{
	if(exiting) return;
	if(!thread_running) init_window();
char buf[1024];
char * e;
va_list ap;
va_start(ap,fmt);
vsnprintf(buf, sizeof(buf)-1, fmt, ap);
va_end(ap);

e=buf+strlen(buf)-1;
	if(e > buf && e[-1]=='\n' && l!=2) *e=0;

memcpy(text[l]+1, buf+1, sizeof(buf)-1);
text[l][0]=buf[0];
	while(text[l][0]) usleep(100000);
}

void gtk::get_str(char * prompt, char * buf, int n, bool pass)
{
masked=pass;
reply=NULL;
question=prompt;
	while(!reply) usleep(100000);
strncpy(buf, reply, n);
buf[n-1]=0;
}

/*** simple setup window ******************************************************/

static void add_known_hosts(char * file, GList * &list)
{
ifstream in(file);
	if(!in) return;
char buf[1000];
	do{
	buf[0]=0;
	in.getline(buf, sizeof(buf));

	char * tmp=strchr(buf, ' ');
		if(!tmp) continue;
	*tmp=0;
	tmp=strchr(buf, ',');
		if(tmp) *tmp=0;
	
	list=g_list_append(list, strdup(buf));
	}while(in.good());
}

static GList * create_hosts_list()
{
char buf[1000];
char * home=getenv("HOME");
GList * list=NULL;
	if(home){
	snprintf(buf, sizeof(buf), "%s/.ssh/known_hosts", home);
	add_known_hosts(buf, list);
	strcat(buf, "2");
	add_known_hosts(buf, list);
	}

ifstream hosts("/etc/hosts");
	if(hosts) do{
	buf[0]=0;
	hosts.getline(buf, sizeof(buf));

		for(char * c=buf;*c;){
		char * start=c;
			for(;*c && !isspace(*c);c++);

			if(start > buf){
			char o=*c;
			*c=0;
			list=g_list_append(list, strdup(start));
			*c=o;
			}
			
			for(;*c && isspace(*c);c++);
		}

	}while(hosts.good());

g_list_sort(list, (GCompareFunc) strcasecmp);

GList * last=NULL;
	for(GList * l=list;l;){
	GList * next=l->next;
		if(!last) last=l;
		else{
			if(!strcasecmp((char*)l->data, (char*)last->data)){
			last->next=l->next;
			delete [] (char*)l->data;
			g_list_free_1(l);
			}else last=l;
		}
	l=next;
	}
	
return list;
}

static void btn_clicked(GtkWidget * btn, int * arg)
{
	if(arg) *arg=1;
gtk_main_quit();
}

static void spin_changed(GtkAdjustment * a, int * tgt)
{
*tgt=(int)a->value;
}

static void checkbox_toggled(GtkToggleButton * tb, bool * tgt)
{
*tgt=gtk_toggle_button_get_active(tb);
}

static void pick_file()
{
/*
GtkWidget * fs=gtk_file_selection_new("Choose filename");
gtk_window_set_position((GtkWindow*)fs, GTK_WIN_POS_CENTER);
gtk_window_set_modal((GtkWindow*)fs, true);

int ok=0;
gtk_signal_connect((GtkObject*)((GtkFileSelection*)fs->ok_button), "clicked",
		(GtkSignalFunc)btn_clicked, &ok);
*/
}

bool gtk::setup(char * &host, char * &file)
{
GtkWidget *win, *hb, *vb;
GtkWidget *w, *eUser, *cbHost, *eFile;

win=gtk_window_new(GTK_WINDOW_TOPLEVEL);
gtk_window_set_policy((GtkWindow*)win, false, false, true);
gtk_window_set_position((GtkWindow*)win, GTK_WIN_POS_CENTER);
gtk_window_set_title((GtkWindow*)win, "proSilla " VERSION);
gtk_container_border_width((GtkContainer*)win, 8);

vb=gtk_vbox_new(false, 4);
gtk_widget_show(vb);
gtk_container_add((GtkContainer*)win, vb);

hb=gtk_hbox_new(false, 4); gtk_widget_show(hb);
gtk_box_pack_start((GtkBox*)vb, hb, false, false, 0);
	w=gtk_label_new("source:");
	gtk_widget_show(w);
	gtk_box_pack_start((GtkBox*)hb, w, false, false, 0);
	
	eUser=gtk_entry_new();
	gtk_entry_set_text((GtkEntry*)eUser, getenv("USER"));
	gtk_widget_set_usize(eUser, 50, -1);
	gtk_widget_show(eUser);
	gtk_box_pack_start((GtkBox*)hb, eUser, false, false, 0);

	w=gtk_label_new("@");
	gtk_widget_show(w);
	gtk_box_pack_start((GtkBox*)hb, w, false, false, 0);

	cbHost=gtk_combo_new();
	gtk_widget_set_usize(cbHost, 150, -1);
	GList * hosts=create_hosts_list();
	gtk_combo_set_popdown_strings((GtkCombo*)cbHost, hosts);
	g_list_foreach(hosts, (GFunc)free, NULL);
	g_list_free(hosts);
	gtk_widget_show(cbHost);
	gtk_box_pack_start((GtkBox*)hb, cbHost, true, true, 0);

hb=gtk_hbox_new(false, 4); gtk_widget_show(hb);
gtk_box_pack_start((GtkBox*)vb, hb, false, false, 0);
	w=gtk_label_new("file:");
	gtk_widget_show(w);
	gtk_box_pack_start((GtkBox*)hb, w, false, false, 0);

	eFile=gtk_entry_new();
	gtk_widget_show(eFile);
	gtk_box_pack_start((GtkBox*)hb, eFile, true, true, 0);
/*
	w=gtk_button_new_with_label("...");
	gtk_widget_show(w);
	gtk_box_pack_start((GtkBox*)hb, w, false, false, 0);
	gtk_signal_connect((GtkObject*)w,...);
*/
hb=gtk_hbox_new(false, 4); gtk_widget_show(hb);
gtk_box_pack_start((GtkBox*)vb, hb, false, false, 0);
	w=gtk_label_new("use ");
	gtk_widget_show(w);
	gtk_box_pack_start((GtkBox*)hb, w, false, false, 0);

	w=(GtkWidget*)gtk_adjustment_new(4, 1, 20, 1, 1, 0);
	gtk_signal_connect((GtkObject*)w, "value-changed", 
			(GtkSignalFunc)spin_changed, (void*)&fle.parts);
	w=gtk_spin_button_new((GtkAdjustment*)w, 1, 0);
	gtk_widget_show(w);
	gtk_box_pack_start((GtkBox*)hb, w, false, false, 0);
	
	w=gtk_label_new(" connections");
	gtk_widget_show(w);
	gtk_box_pack_start((GtkBox*)hb, w, false, false, 0);

w=gtk_check_button_new_with_label("continue interrupted simple download");
gtk_widget_show(w); gtk_box_pack_start((GtkBox*)vb, w, false, false, 0);
gtk_signal_connect((GtkObject*)w, "toggled", (GtkSignalFunc)checkbox_toggled,
							(void*)&fle.recover);

w=gtk_check_button_new_with_label("ignore timestamp/size mismatch");
gtk_widget_show(w); gtk_box_pack_start((GtkBox*)vb, w, false, false, 0);
gtk_signal_connect((GtkObject*)w, "toggled", (GtkSignalFunc)checkbox_toggled,
							(void*)&fle.force);

w=gtk_hseparator_new();
gtk_widget_show(w); gtk_box_pack_start((GtkBox*)vb, w, false, false, 0);

hb=gtk_hbox_new(true, 4); gtk_widget_show(hb);
gtk_box_pack_start((GtkBox*)vb, hb, false, false, 0);

int ok;

	w=gtk_button_new_with_label("Start!");
	GTK_WIDGET_SET_FLAGS(w, GTK_CAN_DEFAULT);
	gtk_widget_grab_default(w);
	gtk_widget_show(w);
	gtk_box_pack_start((GtkBox*)hb, w, true, true, 0);
	gtk_signal_connect((GtkObject*)w, "clicked", (GtkSignalFunc)btn_clicked, (void*)&ok);
	
	w=gtk_button_new_with_label("Exit");
	GTK_WIDGET_SET_FLAGS(w, GTK_CAN_DEFAULT);
	gtk_widget_show(w);
	gtk_box_pack_start((GtkBox*)hb, w, true, true, 0);
	gtk_signal_connect((GtkObject*)w, "clicked", (GtkSignalFunc)btn_clicked, NULL);

gtk_signal_connect((GtkObject*)win, "delete-event", (GtkSignalFunc)btn_clicked, NULL);
gtk_widget_show(win);

	for(;;){
	ok=0;
	gtk_main();
		if(!ok) break;

	char * u=gtk_entry_get_text((GtkEntry*)eUser);
	
	char * h=gtk_entry_get_text((GtkEntry*)((GtkCombo*)cbHost)->entry);
		if(!h || !*h) continue;
	
	char * f=gtk_entry_get_text((GtkEntry*)eFile);
		if(!f || !*f) continue;

		if(!u || !*u){
		host=strdup(h);
		}else{
		int l=strlen(h)+strlen(u)+3;
		host=new char[l];
		sprintf(host, "%s@%s", u, h);
		}
	
	file=strdup(f);
	break;
	}

gtk_widget_destroy(win);
return (ok!=0);
}

/*** main gtk-thread refresh function *****************************************/

int gtk_refresh_function(gtk * g)
{
	if(g->quit){
	g->exiting=true;
	g->quit=false;
	gtk_main_quit();
	return 0;
	}

	if(g->question){
	gtk_label_set_text((GtkLabel*)g->lbl2, g->question);
	gtk_entry_set_text((GtkEntry*)g->qbox, "");
	gtk_widget_show(g->qbox);
	gtk_widget_grab_focus(g->qbox);
	gtk_entry_set_visibility((GtkEntry*)g->qbox, !g->masked);
	g->question=NULL;
	
	}

	for(int i=0;i<3;i++) if(g->text[i][0]){
		switch(i){
		case 0:
		gtk_label_set_text((GtkLabel*)g->lbl1, g->text[i]); break;
		case 1:
		gtk_label_set_text((GtkLabel*)g->lbl2, g->text[i]); break;
		case 2:
		gtk_text_insert((GtkText*)g->status, NULL, NULL, NULL, 
					g->text[i], -1); break;
		}
	g->text[i][0]=0;
	}
	
	for(int i=0;i<=fle.parts;i++){
	int v, max, ok, in;
		if(i < fle.parts){
		v=threads[i].bytes;
		max=threads[i].max;
		ok=threads[i].status;
		in=threads[i].initbytes;

		}else{
		v=fle.totalbytes;
		max=fle.size;
		ok=(v<max)?1:2;
		in=fle.totinitbytes;
		}

		if(!g->configured){
			if(g->configure){
			gtk_progress_configure(g->progress[i],
					(float)v/1024, 0, (float)max/1024);
			gtk_progress_set_format_string(g->progress[i], 
							"%2V kb (%P %%)");
			}
		continue;
		}

	gtk_progress_set_value(g->progress[i], (float)v/1024);

	char buf[20];
	buf[0]=0;
		switch(ok){
		case 0: strcpy(buf, "CONNECTING"); break;
		
		case 2:
		gtk_label_set_text(g->eta[i], "FINISHED"); break;
		case 1:
			if(now <= started){
			buf[0]=0;
			break;
			}
		sprintf(buf, "%6.2fkb/s", (double)(v-in)/(1024*(now-started)));
		}

		if(buf[0]) gtk_label_set_text(g->transfer[i], buf);

		if(now > started && ok==1){
		int eta_s=eta(v-in, max-in);
		sprintf(buf, "ETA %2d:%02d:%02d",
				(eta_s/3600), (eta_s/60)%60, eta_s%60);
		gtk_label_set_text(g->eta[i], buf);
		}
	}

	if(g->configure){
	g->configured=true;
	g->configure=false;
	}
return 1;
}

static void thread_func(gtk * g)
{
sigset_t mask;
sigfillset(&mask);
pthread_sigmask(SIG_SETMASK, &mask, NULL);

gtk_main();
g->destroy_window();
	while(gtk_events_pending()) gtk_main_iteration();
	if(!g->exiting) kill(g->main_pid, SIGINT);
}

void gtk::updateinfo(thread * th, int)
{
	if(th || configure || configured) return;
configure=true;
}

/*** gui initialization *******************************************************/

static void activate_handler(GtkEntry * e, char ** tgt)
{
gtk_widget_hide((GtkWidget*)e);
*tgt=gtk_entry_get_text(e);
}

static void go_to_background(GtkButton * shit, gtk * g)
{
g->destroy_window();
	while(gtk_events_pending()) gtk_main_iteration();
g->exiting=true;
kill(g->main_pid, SIGHUP);
_exit(0);
}

void gtk::init_window()
{
thread_running=true;

GtkWidget *vb, *hb;
GtkWidget *w;

win=gtk_window_new(GTK_WINDOW_TOPLEVEL);
gtk_window_set_default_size((GtkWindow*)win, 400, 150);
gtk_window_set_title((GtkWindow*)win, banner);
gtk_container_border_width((GtkContainer*)win, 8);
gtk_signal_connect((GtkObject*)win, "delete-event", (GtkSignalFunc)gtk_main_quit, NULL);

vb=gtk_vbox_new(false, 4);
gtk_widget_show(vb);
gtk_container_add((GtkContainer*)win, vb);

lbl1=gtk_label_new(""); gtk_widget_show(lbl1);
gtk_box_pack_start((GtkBox*)vb, lbl1, false, false, 0);

hb=gtk_hbox_new(false, 4); gtk_widget_show(hb);
gtk_box_pack_start((GtkBox*)vb, hb, false, false, 0);

	lbl2=gtk_label_new(""); gtk_widget_show(lbl2);
	gtk_box_pack_start((GtkBox*)hb, lbl2, true, true, 0);
	
	qbox=gtk_entry_new(); //gtk_widget_show(qbox);
	gtk_box_pack_start((GtkBox*)hb, qbox, true, true, 0);
	gtk_signal_connect((GtkObject*)qbox, "activate", (GtkSignalFunc)activate_handler, (void*)&reply);

w=gtk_table_new(fle.parts+2, 4, false);
gtk_table_set_row_spacings((GtkTable*)w, 4);
gtk_table_set_col_spacings((GtkTable*)w, 4);
gtk_widget_show(w);
gtk_box_pack_start((GtkBox*)vb, w, true, true, 0);

progress = new GtkProgress*[fle.parts+1];
transfer = new GtkLabel*[fle.parts+1];
eta = new GtkLabel*[fle.parts+1];

	for(int i=0;i<=fle.parts;i++){
	int r;
	char b[10];

		if(i < fle.parts){
		r=i;
		sprintf(b, "%d.", i+1);
		
		}else{
		GtkWidget * s=gtk_hseparator_new();
		gtk_widget_show(s);
		gtk_table_attach((GtkTable*)w, s, 0, 4, i, i+1,
					GTK_FILL, (GtkAttachOptions)0, 0, 0);

		r=i+1;
		strcpy(b, "tot.");
		}

	GtkWidget * ww;
	ww=gtk_label_new(b);
	gtk_widget_show(ww);
	gtk_table_attach((GtkTable*)w, ww, 0, 1, r, r+1, GTK_FILL,
						(GtkAttachOptions)0, 0, 0);
	
	progress[i]=(GtkProgress*)gtk_progress_bar_new();
	gtk_progress_configure(progress[i], 0, 0, 100);
	gtk_progress_set_show_text(progress[i], true);
	gtk_widget_show((GtkWidget*)progress[i]);
	gtk_table_attach((GtkTable*)w, (GtkWidget*)progress[i], 1, 2, r, r+1,
	(GtkAttachOptions)(GTK_EXPAND|GTK_FILL), (GtkAttachOptions)0, 0, 0);
		
	ww=gtk_label_new(""); gtk_widget_show(ww);
	gtk_widget_set_usize(ww, 80, -1);
	gtk_table_attach((GtkTable*)w, ww, 2, 3, r, r+1, GTK_FILL, 
						(GtkAttachOptions)0, 0, 0);
	transfer[i]=(GtkLabel*)ww;

	ww=gtk_label_new(""); gtk_widget_show(ww);
	gtk_widget_set_usize(ww, 80, -1);
	gtk_table_attach((GtkTable*)w, ww, 3, 4, r, r+1, GTK_FILL, 
						(GtkAttachOptions)0, 0, 0);
	eta[i]=(GtkLabel*)ww;
	}

status=gtk_text_new(NULL, NULL); 
gtk_text_set_editable((GtkText*)status, false);
gtk_widget_set_usize(status, -1, 60);
gtk_widget_show(status);
gtk_box_pack_start((GtkBox*)vb, status, false, false, 0);

hb=gtk_hbox_new(true, 4); gtk_widget_show(hb);
gtk_box_pack_start((GtkBox*)vb, hb, false, false, 0);
	w=gtk_button_new_with_label("Background");
	gtk_box_pack_start((GtkBox*)hb, w, true, true, 0);
	gtk_widget_show(w);
	gtk_signal_connect((GtkObject*)w, "clicked", (GtkSignalFunc)go_to_background, (void*)this);
	
	w=gtk_button_new_with_label("Exit");
	gtk_box_pack_start((GtkBox*)hb, w, true, true, 0);
	gtk_widget_show(w);
	gtk_signal_connect((GtkObject*)w, "clicked", (GtkSignalFunc)gtk_main_quit, NULL);

gtk_widget_show(win);

gtk_timeout_add(100, (GtkFunction)gtk_refresh_function, (void*)this);

pthread_t t;
pthread_create(&t, NULL, (void *(*)(void*)) thread_func, (void*)this);
}
