#ifndef _IFACE_H
#define _IFACE_H

#include <ncurses.h>

typedef unsigned long fsize_t;		// FIXME: it is also in thread.h!!!
extern time_t now, started;

class thread;

class iface {
protected:
	// prepares one line of statistics, used by simple and ncurses
	int prepareinfo(thread * th, int n, char * buf, fsize_t size);
public:
	// updates displayed statistics
	void virtual updateinfo(thread * th, int n){};
	
	// displays a message, l - only matters for ncurses/gtk
	// 0 -> second line
	// 1 -> third line
	// 2 -> bottom "console" window
	void virtual msg(int l,char *fmt,...){};

	// displays errors from a pipe
	void printerror(int fd);
	
	void virtual refresh(){};
	void virtual eatkey(){};

	bool virtual setup(char * &host, char * &file){ return false; }

	void virtual get_str(char * prompt, char * buf, int n, bool pass=false);

	virtual ~iface(){};
};

/***/

class ncurses:public iface {
private:
	static const int cons_h=5;
	WINDOW *Wmain, *Wcons;
public:
	void updateinfo(thread * th, int n);
	void msg(int l,char *fmt,...);
	void refresh();
	void eatkey();
	void get_str(char * prompt, char * buf, int n, bool pass=false);

	ncurses();
	~ncurses();
};

/***/

class simple:public iface{
	bool printedstatus;
public:
	void updateinfo(thread * th, int n);
	void msg(int l,char *fmt,...);
	void eatkey();
	void refresh();

	simple();
};

extern iface* Iface;

int inline eta(fsize_t bytes, fsize_t max)
{
return (int)((now-started)*(((double)max/bytes)-1));
}

extern const char banner[];
#endif
