.TH prosilla 1 "12 April 2005" 
.SH NAME
proSilla \- transfer accelerator working over ssh.
.SH SYNOPSIS
.B prosilla [
.BI options
.B ]
.BI [user@]host
.BI file

.B gprosilla [
.BI options
.B ]
.BI [user@]host
.BI file

.B prosilla -i
.BI file.psinfo 
.B [
.BI file2.psinfo...
.B ]

.SH DESCRIPTION
.B ProSilla
is a program which accelerates file transfers over ssh by opening
multiple connections just like other download accelerators. The only difference
is that proSilla uses ssh instead of http/ftp for download. Of course you must
have a shell account on the remote server to use this program.
.PP
Yes, the name and idea is based on
.B prozilla,
but the source code is not.

.SH OPTIONS
.TP
.BI \-b
Go to background after logging in, implies -q (quiet mode)
.TP
.BI \-c
Continue a simple download - such as scp or wget. Do not use this option to resume proSilla transfers, proSilla will detect partial downloads automatically.
.TP
.BI \-f
Download even if the size or modification time stored in the .psinfo file doesn't match the remote file. This usually means that the remote file was modified and resuming the download might not be reliable.
.TP
.BI \-k\ n
Use
.B n
simulatenous connections to accelerate the transfer. Default: 4. -k 1 is useful if you simply want to transfer a file with resume support.
.TP
.BI \-p[prog]
Use
.B prog
as "prosilla server". The server program is not required in the current version (/bin/dd is used instead).If you really want to use it (for a tiny performance increase), you can specify the path to "proserv" as an argument to -p. Using -p alone defaults to ~/bin/proserv.
.TP
.BI \-s\ arg
Pass argument
.B arg
to ssh. For example:
.B -s -c -s blowfish
.TP
.BI \-C
Use ssh compression, equivalent to
.B -s -C
.TP
.BI \-g
Use the gtk+ interface. This is equivalent to calling prosilla as
.B gprosilla
. Available only if compiled with gtk+ support.
.TP
.BI \-N
Don't use the ncurses interface, but a simple text interface.
.TP
.BI \-n
Don't wait for a keystroke before exiting.
.TP
.BI \-q
Quiet mode: don't show anything, just download.
.TP
.BI \-i
Show the status of a running or stopped transfer from a 
.B .psinfo
file. This file is created when you start downloading and removed after successfully finishing the download, it holds information about the remote file and transfer progress.

.SH EXAMPLES
.PP
The simplest way to use prosilla in text mode is:
.PP
	prosilla host.some.where remote/dir/file
.PP
or
.PP
	prosilla me@host.some.where remote/dir/file
.PP
Resuming a broken scp transfer (this assumes that partially downloaded file 'foo' resides in the current directory):
.PP
	prosilla -c -k1 remote.host remote/dir/foo
.PP
See the progress of all downloads in the current directory
.PP
	prosilla -i *.psinfo

.SH SEE ALSO
.BR proserv (1),
.BR ssh (1),
.BR scp (1),
.BR proz (1).
.SH NOTES
.PP
Do not use this program on a fast connection (LAN or something) - it will only slow things down.
.SH BUGS
.PP
Transferring files larger than 2GB won't work - and I won't implement it soon
since I'm not going to test it on my 115kbit connection.
.PP
The 'Background' option in the GUI doesn't remove the application icon from
the screen (at least in WindowMaker) - dealing with it will be difficult
because gtk/gdk don't have a clean-up-and-disconnect-from-xserver function.
